/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in 
 * compliance with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2007.  All Rights Reserved.
 *
 * Protege was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu.
 *
 */

package edu.stanford.smi.protege.ui;

import java.util.*;

import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.resource.*;
import edu.stanford.smi.protege.util.*;

class DisplaySlotRenderer extends DefaultRenderer {

    DisplaySlotRenderer(Cls cls) {
    }

    public void loadNull() {
        clear();
    }

    public void load(Object o) {
        if (o instanceof BrowserSlotPattern) {
            BrowserSlotPattern pattern = (BrowserSlotPattern) o;
            addText(pattern);
        } else {
            addText(o.toString());
        }
        setBackgroundSelectionColor(Colors.getSlotSelectionColor());
    }

    private void addText(BrowserSlotPattern pattern) {
        Iterator i = pattern.getElements().iterator();
        while (i.hasNext()) {
            Object o = i.next();
            if (o instanceof Slot) {
                Slot slot = (Slot) o;
                addIcon(slot.getIcon());
                addText(slot.getBrowserText());
            } else {
                addText(o.toString());
            }
        }
    }
}